summaryrefslogtreecommitdiff
path: root/helpers/chroot_local-hooks
diff options
context:
space:
mode:
authorDaniel Baumann <daniel@debian.org>2010-02-05 17:10:44 +0100
committerDaniel Baumann <daniel@debian.org>2011-03-09 19:17:04 +0100
commit3b80c5c5d9c9d2eec91910b70a120da5943c7fac (patch)
tree31b5fef2977e7fabe669077041c569169c788a95 /helpers/chroot_local-hooks
parent59e9a93ad08c171fb0d22e965c56f91c5bd17615 (diff)
downloadlive-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.zip
live-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.tar.gz
Dropping lh_ prefix from internal helpers, this is not user visible.
Diffstat (limited to 'helpers/chroot_local-hooks')
-rwxr-xr-xhelpers/chroot_local-hooks69
1 files changed, 69 insertions, 0 deletions
diff --git a/helpers/chroot_local-hooks b/helpers/chroot_local-hooks
new file mode 100755
index 0000000..0155e79
--- /dev/null
+++ b/helpers/chroot_local-hooks
@@ -0,0 +1,69 @@
+#!/bin/sh
+
+# lh_chroot_local-hooks(1) - execute local hooks in chroot
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'execute local hooks in chroot')"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+Echo_message "Begin executing local hooks..."
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+# Checking stage file
+Check_stagefile .stage/chroot_local-hooks
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+# Processing local-hooks
+if Find_files config/chroot_local-hooks/*
+then
+ # Restoring cache
+ Restore_cache cache/packages_chroot
+
+ for HOOK in config/chroot_local-hooks/*
+ do
+ # Copying hook
+ cp "${HOOK}" chroot/root
+
+ # Making hook executable
+ if [ ! -x chroot/root/"$(basename ${HOOK})" ]
+ then
+ chmod +x chroot/root/"$(basename ${HOOK})"
+ fi
+
+ # Executing hook
+ Chroot chroot "/root/$(basename ${HOOK})" || ( Echo_error "${HOOK} failed (exit non-zero). You should check for errors."; exit 1 )
+
+ # Removing hook
+ rm -f chroot/root/"$(basename ${HOOK})"
+ done
+
+ # Saving cache
+ Save_cache cache/packages_chroot
+
+ # Creating stage file
+ Create_stagefile .stage/chroot_local-hooks
+fi